<?php
function water_tag_cloud( $args = '' ) {
	global $water;
	if( $water['hide_tag_cloud'] )
		return;

	$defaults = array(
		'smallest' => 8, 'largest' => 22, 'unit' => 'pt', 'number' => 45,
		'format' => 'flat', 'orderby' => 'name', 'order' => 'ASC',
		'exclude' => '', 'include' => ''
	);

	$args = wp_parse_args( $args, $defaults );

	$tags = get_tags( array_merge($args, array('orderby' => 'count', 'order' => 'DESC')) ); // Always query top tags

	if ( empty($tags) )
		return;

	$return = wp_generate_tag_cloud( $tags, $args ); // Here's where those top tags get sorted according to $args

	if ( is_wp_error( $return ) )
		return false;

	$return = apply_filters( 'wp_tag_cloud', $return, $args );

	if ( empty($return) )
		return ?>
		<li>
			<h3>Popular Tags</h3>
			<?php echo $return; ?>
		</li><?php
}

// Sidebar stuff
if( function_exists('register_sidebar') ) {
	register_sidebar(array(
		'name' => 'Right Sidebar',
		'id' => "sidebar-1",
		'before_widget' => '<li id="%1$s" class="widget %2$s">',
		'after_widget' => "</li>\n",
		'before_title' => '<h3 class="widgettitle">',
		'after_title' => "</h3>\n"));

	register_sidebar(array(
		'name' => 'Left Sidebar',
		'id' => "sidebar-2",
		'before_widget' => '<li id="%1$s" class="widget %2$s">',
		'after_widget' => "</li>\n",
		'before_title' => '<h3 class="widgettitle">',
		'after_title' => "</h3>\n"));
}

function widget_water_search() { ?>
		<li id="search" class="widget search">
			<h3>Search</h3>
			<form id="searchform" method="get" action="<?php bloginfo('home'); ?>">
				<input type="text" value="<?php echo wp_specialchars($s, 1); ?>" name="s" id="s" />
			</form>
		</li><?php
}

if( function_exists('register_sidebar_widget') ) { register_sidebar_widget(__('Search'), 'widget_water_search'); }

function widget_water_calendar() {
	global $sbtitle, $posts;
	if( empty($posts) )
		return;
	$options = get_option('widget_calendar');
	$title = apply_filters('widget_title', $options['title']);
	if ( empty($title) ) $title = 'Calendar' ?>
		<li class="widget calendar">
			<h3><?php _e($title); ?></h3>
			<?php get_calendar(); ?>
		</li><?php
}

if( function_exists('wp_widget_calendar') ) { register_sidebar_widget(__('Calendar'), 'widget_water_calendar'); }
?>